#!/usr/bin/perl -T
# $Id: logbook.cgi,v 1.7 2016/12/19 10:00:02 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use CGI qw(:standard :netscape);
use SemaforeFile;
use LWP::UserAgent;


my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if (&login_ok())
    { 
        &print_header("Logbook for rig ".$rig->name);
        print RFC_start_html(-title=>"Rig ".$rig->name." logbook", -style=>{src=>'/celltest/RFCcontrol.css'});
        top_nav_bar_start;
	top_no_button;
	top_no_button;
	top_no_button;
	tab_newrow;
        if (&get_CGI_value_clean('action'))
        {
            top_no_button;
        }
        else
        {
            &js_back();
            top_js_return('#006600','white');
        }
	top_no_button;
	top_no_button;
        top_nav_bar_button('rig_main.cgi','','','To rig'.$rig->name.' main page','s3','rig,'.$rig->name.',1');
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar;
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /^Save/ and do {&save; &insert_data_form(); last CASE;};
	    ### Default response ####
    	    &insert_data_form;
	}	
	print_end;
    }
    else 
    {
	&not_auth;
    }
}
    
exit;

sub save
{
    my $logall = &get_CGI_value('log_all');
    my $string = &get_CGI_value('text');
    my $time = localtime;
    my $user = get_user();
    my $str = $time.": User $user added:\n".$string."\n\n";
    eval
    {
	foreach my $rigname (&RFC::Main::get_rigs())
	{
	    my $r = RFC::Rig->new($rigname);
	    next unless ($logall || $r->name == $rig->name);
	    my $f = $RFC::Header::publicdir.'rig'.$r->name.'/logbook.txt';
	    my $l = $r->riglock; 
	    my $file = SemaforeFile->new($f,$l);
	    my $test = $r->session;
	    $f = $RFC::Header::publicdir.'rig'.$r->name.'/'.$r->name.'test'.$test.'/info.txt';
	    my $info = SemaforeFile->new($f,$l);
	    $file->append($str);
	    $info->append($str);
	    my $equipid = $r->get_cv('main','equipmentid');
	    &remote_log($equipid,$string) if ($equipid);
	}
    };
    if ($@)
    {
	&errorlog($@);
	&print_error();
    }
}



sub remote_log($$)
{
    my $eqid = shift;
    my $msg = shift;
    my $eqadr = get_cv('global','remote_equipment_database');
    return unless ($eqadr);
    my $ua = LWP::UserAgent->new();
    $ua->timeout(60);
    my $url = $eqadr;
    my $query = '?name='.&get_user().'&pass='.&get_pass().'&action=new_maint_log&type=Riglog&equipid='.$eqid.'&description='.$msg;
    my $request = new HTTP::Request('GET',$url.$query);
    my $response = $ua->request($request);
    return if ($response->is_success);
    &errorlog("Could not append mesage to remote message log for rig $rig!");
}


sub insert_data_form
{

    my $equipid = $rig->get_cv('main','equipmentid');
    $equipid = 0 unless ($equipid);
    my $eqadr = get_cv('global','remote_equipment_database');
    $eqadr = '' unless ($eqadr);
    my $f = $RFC::Header::publicdir.'rig'.$rig->name.'/logbook.txt';
    my $l = $rig->riglock; 
    my $file = SemaforeFile->new($f,$l);
    my $test = $rig->session;
    $f = $RFC::Header::publicdir.'rig'.$rig->name.'/'.$rig->name.'test'.$test.'/info.txt';
    my $info = SemaforeFile->new($f,$l);
    my $str = join("\n",$file->readlines);
    print start_form(-name=>'sofc',-class=>"form",-onsubmit=>'return store_comment()');
    &print_hidden_rig;  
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=20>';
    print '<td width="10%"></td>';
    print '<td width="40%"></td>';
    print '<td width="40%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    print '<tr><td colspan=4 class="heading">';
    print "Logbook for rig ".$rig->name;
    print '</td></tr>';
    print '<tr><td height=20></td></tr>';
    print '<tr><td></td><th valign=top>';
    print textarea(-name=>'test',-value=>$str,-class=>'textfield',-rows=>'30',-force=>'1');
    print '</th><th valign=top>';
    print checkbox(-name=>'log_all',-checked=>0,-force=>1,-label=>'Add to logbook for all rigs on this server');
    print textarea(-name=>'text',-value=>'',-class=>'textfield',-rows=>'26',-force=>'1');
    &menu_button('action','Save new entry','s3');
    print '</th></tr></table>';
    print hidden(-name=>'eqid',-value=>$equipid,-force=>1);
    print hidden(-name=>'addr',-value=>$eqadr,-force=>1);
    print end_form();

    print <<END;

<script>


function store_comment()
{
    var f = document.sofc;
    var str = f.text.value;
    var adr = f.addr.value;
    var id = f.eqid.value;
    document.login_info.testnr.value = -1;
    if (id == 0 || adr == '')
    {
        return true;
    }
    if (f.log_all.checked)
    {
        return true;
    }
    else
    {
	remote_log(adr,id,str);
    }
    return true;
}


</script>

END


}

